
// Name
//===================================
//
// Collision
//


// DEPENDENCIES
//===================================

    #include "collision.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    Collision::Collision
    (
        Direction::Simple direction,
        int overlap_x,
        int overlap_y,
        Direction::Horizontal direction_x,
        Direction::Vertical direction_y,
        int overlap_x_left,
        int overlap_x_right,
        int overlap_y_top,
        int overlap_y_bottom
    )
    :
        direction_   ( direction ),
        overlap_x_   ( overlap_x ),
        overlap_y_   ( overlap_y ),
        direction_x_ ( direction_x ),
        direction_y_ ( direction_y ),
        overlap_x_left_   ( overlap_x_left ),
        overlap_x_right_  ( overlap_x_right ),
        overlap_y_top_    ( overlap_y_top ),
        overlap_y_bottom_ ( overlap_y_bottom )
    {};

    Direction::Simple Collision::direction() const
    {
        return direction_;
    };

    Direction::Horizontal Collision::directionX() const
    {
        return direction_x_;
    };

    Direction::Vertical Collision::directionY() const
    {
        return direction_y_;
    };

    int Collision::overlapX() const
    {
        return overlap_x_;
    };

    int Collision::overlapY() const
    {
        return overlap_y_;
    };


    int Collision::overlapXLeft() const
    {
        return overlap_x_left_;
    };
    int Collision::overlapXRight() const
    {
        return overlap_x_right_;
    };
    int Collision::overlapYTop() const
    {
        return overlap_y_top_;
    };
    int Collision::overlapYBottom() const
    {
        return overlap_y_bottom_;
    };


    bool Collision::collideLeft() const
    {
        return overlapXLeft() > 0;
    };
    bool Collision::collideRight() const
    {
        return overlapXRight() > 0;
    };
    bool Collision::collideTop() const
    {
        return overlapYTop() > 0;
    };
    bool Collision::collideBottom() const
    {
        return overlapYBottom() > 0;
    };
    bool Collision::collideAny() const
    {
        return ( collideLeft() || collideRight() || collideTop() || collideBottom() );
    };
