
// Name
//===================================
//
// Collision
//

#ifndef COLLISION_H
#define COLLISION_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "direction.h"


// CLASS
//===================================

    class Collision
    {
        public:
            Direction::Simple direction()      const;
            Direction::Horizontal directionX() const;
            Direction::Vertical directionY()   const;
            int overlapX()                     const;
            int overlapY()                     const;
            int overlapXLeft()                 const;
            int overlapXRight()                const;
            int overlapYTop()                  const;
            int overlapYBottom()               const;
            bool collideLeft()                 const;
            bool collideRight()                const;
            bool collideTop()                  const;
            bool collideBottom()               const;
            bool collideAny()                  const;

            Collision
            (
                Direction::Simple direction,
                int overlap_x,
                int overlap_y,
                Direction::Horizontal direction_x,
                Direction::Vertical direction_y,
                int overlap_x_left,
                int overlap_x_right,
                int overlap_y_top,
                int overlap_y_bottom
            );

        private:
            const Direction::Simple direction_;
            const Direction::Horizontal direction_x_;
            const Direction::Vertical direction_y_;
            const int overlap_x_;
            const int overlap_y_;
            const int overlap_x_left_;
            const int overlap_x_right_;
            const int overlap_y_top_;
            const int overlap_y_bottom_;
    };

#endif // COLLISION_H
