


// Name
//===================================
//
// PlayerGraphics
//


// DEPENDENCIES
//===================================

    #include "player_graphics.h"
    #include "sprite.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    PlayerGraphics::PlayerGraphics()
    :
        SpriteGraphics ( Graphics::SpriteSheet::LVSPRITES_AUTUMN )
    {};

    PlayerGraphics::~PlayerGraphics() {};

    void PlayerGraphics::update( Sprite& sprite )
    {
        if ( sprite.directionX() == Direction::Horizontal::RIGHT )
            flip_x_ = true;
        else
            flip_x_ = false;

        if ( sprite.isDucking() )
        {
            current_frame_x_ = 64;
            current_frame_y_ = 6;
        }
        else if ( !sprite.onGroundPrev() )
        {
            current_frame_x_ = 48;
            current_frame_y_ = 0;
        }
        else if ( sprite.isMoving() )
        {
            if ( walk_timer_.hit() )
            {
                ++walk_counter_;
            }

            walk_timer_.update();

            switch ( walk_counter_.value() )
            {
                case 1:
                    current_frame_x_ = 0;
                    break;
                case 2:
                    current_frame_x_ = 32;
                    break;
                case 3:
                    current_frame_x_ = 0;
                    break;
                default:
                    current_frame_x_ = 16;
            }

            current_frame_y_ = 0;
        }
        else
        {
            current_frame_x_ = 0;
            current_frame_y_ = 0;
        }
    };

