
// Name
//===================================
//
// SpriteGraphics
//

#ifndef SPRITE_GRAPHICS_H
#define SPRITE_GRAPHICS_H


// FORWARD DECLARATIONS
//===================================

    class Sprite;


// DEPENDENCIES
//===================================

    #include "graphics.h"


// CLASS
//===================================

    class SpriteGraphics
    {
        public:
            SpriteGraphics( Graphics::SpriteSheet texture = Graphics::SpriteSheet::LIMIT );
            virtual ~SpriteGraphics();
            virtual void update( Sprite& sprite ) = 0;
            void render( SDL_Rect bound_box, Graphics& graphics );

        protected:
            class Frame
            {
                public:
                    Frame( std::string id, int x, int y ) : id_ ( id ), x_ ( x ), y_ ( y ) {};
                    int X() { return x_; };
                    int Y() { return y_; };
                    std::string& ID() { return id_; };

                private:
                    int x_ = 0;
                    int y_ = 0;
                    std::string id_ = "";
            };

            Graphics::SpriteSheet texture_ = Graphics::SpriteSheet::LIMIT;
            bool flip_x_ = false;
            bool flip_y_ = false;
            //Frame DEFAULT_FRAME = Frame( "DEFAULT", 0, 0 );
            //Frame* current_frame_ = &DEFAULT_FRAME;
            //Frame* prev_frame_ = &DEFAULT_FRAME;
            int current_frame_x_ = 0;
            int current_frame_y_ = 0;
            int prev_frame_x_ = 0;
            int prev_frame_y_ = 0;
    };


#endif // SPRITE_GRAPHICS_H

